# R FUNCTIONS TO GENERATE DATA SETS FROM A POLYA TREE PRIOR. 
#
# Written by Radford M. Neal, March 2001.


# GENERATE DATA FROM A ONE-DIMENSIONAL POLYA TREE PRIOR.  The parameters
# are the function that defines "alpha" as a function of level in the tree,
# the number of data points to generate, and the depth of the tree, which
# controls the precision to which data points are generated.

pt.gen1 <- function (alpha, n, depth=20, debug=F)
{
  p <- rep(0,2^depth-1)
  for (i in 1:depth)
  { p [(2^(i-1)) : (2^i-1)] <- rbeta (2^(i-1), alpha(i), alpha(i))
  }

  if (debug) print(p)

  d <- rep(0,n)
  for (j in 1:n)
  { v <- 0
    for (i in 1:depth)
    { k <- 2^(i-1)+v
      b <- runif(1) < p[k]
      v <- 2*v + b
    }
    d[j] <- (v+0.5) / 2^depth
  }

  d
}
